package refl;

import java.lang.reflect.*;
import java.util.Vector;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class ClassWindow extends SimpleWindow
{
    private java.awt.Frame win;
    private java.lang.Object obj;
    private java.lang.Class cls;

    public ClassWindow (java.awt.Frame parent, Object n)
    {
        super (parent);
        win = parent;
        obj = n;
        cls = obj.getClass ();
        setTitle (cls.getName ());

        Method [] methods = cls.getMethods ();
        // showList (methods);

        /*
        int cnt = 0;
        for (int i = 0; i < methods.length; i ++)
        {
            Method met = methods [i];
            if (met.getParameterTypes().length == 0)
                cnt ++;
        }

        Method [] vyber = new Method [cnt];

        int k = 0;
        for (int i = 0; i < methods.length; i ++)
        {
            Method met = methods [i];
            if (met.getParameterTypes().length == 0)
                vyber [k++] = met;
        }

        showList (vyber);
        */

        /*
        Vector v = new Vector ();
        v.add (methods [0]);
        Object q = v.get (0);
        */
        
        ArrayList <Method> list = new ArrayList <Method> ();
        for (int i = 0; i < methods.length; i ++)
        {
            Method met = methods [i];
            if (met.getParameterTypes().length == 0)
                list.add (met);
        }

        /*
        Method [] vyber = new Method [list.size()];
        for (int i = 0; i < list.size (); i ++)
                vyber [i] = list.get (i);
         */

        // showList (list);
        showList (list.toArray());
    }

    protected void itemClicked (Object item)
    {
        showInfo ("Click " + item);
        // new MethodWindow (win, obj, (Method) item);
        Method met = (Method) item;
        try
        {
            Object result = met.invoke(obj);
            showInfo("Result " + result);
        }
        catch (Exception ex)
        {
        }

    }

}
